--
-- speedlvlUpdate.lua
--
-- @author  Alex2009
-- @website www.alex2009.de
-- @date    03.10.2013
--
--Modifikation erst nach rcksprache mit dem Autor(Alex2009) erlaubt.
--Modification allowed only after consultation with the author(Alex2009).

speedlvlUpdate = {};

function speedlvlUpdate:loadMap(name)
    self.speedLevel = 1;
    self.newSpeedLevel = 1;
    self.players = 0;
    for _,vehicle in pairs(g_currentMission.vehicles) do
        if vehicle.maxSpeedLevel ~= nil then
            vehicle.maxSpeedLevel = self.speedLevel;
        end;
    end;
    return true;
end;

function speedlvlUpdate:keyEvent(unicode, sym, modifier, isDown)	
end;

function speedlvlUpdate:update(dt)
    if g_currentMission:getIsServer() then
        local players = 0;
        for _,_ in pairs(g_currentMission.players) do
            players = players + 1;
        end;
        if self.players ~= players then
            if g_server ~= nil then
                g_server:broadcastEvent(speedLvlStateUpdate:new(self,self.newSpeedLevel));
            else
                g_client:getServerConnection():sendEvent(speedLvlStateUpdate:new(self,self.newSpeedLevel));
            end;
            self.players = players;
        end;
    end;
    if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
        if g_currentMission.controlledVehicle then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("change_maxspeed"),self.speedLevel), InputBinding.change_maxspeedInput);
            if InputBinding.hasEvent(InputBinding.change_maxspeedInput, true) then
                self.speedLevel = (self.speedLevel+1);
                if self.speedLevel > 2 then
                    self.speedLevel = 1;
                end;
                self.newSpeedLevel = self.speedLevel;
                if g_server ~= nil then
                    g_server:broadcastEvent(speedLvlStateUpdate:new(self,self.newSpeedLevel));
                else
                    g_client:getServerConnection():sendEvent(speedLvlStateUpdate:new(self,self.newSpeedLevel));
                end;
                for _,vehicle in pairs(g_currentMission.vehicles) do
                    if vehicle.maxSpeedLevel ~= nil then
                        vehicle.maxSpeedLevel = self.speedLevel;
                    end;
                end;
            end;
        end;
    end;
end;

function speedlvlUpdate:draw()
end;

function speedlvlUpdate:deleteMap()
end;

function speedlvlUpdate:mouseEvent(posX, posY, isDown, isUp, button)
end;
addModEventListener(speedlvlUpdate);

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
speedLvlStateUpdate = {};
speedLvlStateUpdate_mt = Class(speedLvlStateUpdate, Event);

InitEventClass(speedLvlStateUpdate, "speedLvlStateUpdate");

function speedLvlStateUpdate:readStream(streamId, connection)
  self.object = speedlvlUpdate;
  self.newSpeedLevel = streamReadInt32(streamId);
  self.object.speedLevel = self.newSpeedLevel;
  self.object.newSpeedLevel = self.newSpeedLevel;
  for _,vehicle in pairs(g_currentMission.vehicles) do
    if vehicle.maxSpeedLevel ~= nil then
      vehicle.maxSpeedLevel = self.newSpeedLevel;
    end;
  end;
  if not connection:getIsServer() then
    g_server:broadcastEvent(speedLvlStateUpdate:new(self.object,self.newSpeedLevel), nil, connection);
  end;
end;

function speedLvlStateUpdate:writeStream(streamId, connection)
  streamWriteInt32(streamId, self.speedLvL);
end;

function speedLvlStateUpdate:new(object,speedLvL)
  local self = speedLvlStateUpdate:emptyNew()
  self.object = object;
  self.speedLvL = speedLvL;
  return self;
end;

function speedLvlStateUpdate:emptyNew()
  local self = Event:new(speedLvlStateUpdate_mt);
  self.className="speedLvlStateUpdate";
  return self;
end;